#include <iostream>
#include "time.h"

using namespace std;

#include <math.h>

unsigned __int64 a[1000], b[1000];
unsigned __int64 p[2000];

unsigned __int64 Integer_Divide_M(int n);          

int main()
{
    double start, finish;
	char kind;
	int id, n, k;
	cout << "--------------- Integer Splitting---------------\n";

	while (1)
	{
        cout << "Please enter integer n(-1 to exit)"<<endl;
        cin >> n;
        if(n==-1)
            break;
        start = (double)clock();
        unsigned __int64 result;
        result = Integer_Divide_M(n);
        if (result > 0)
            printf("The number of integer splitting p(%d) = %I64u \n",n,result);
        finish = (double)clock();
        printf("Running time ");
        printf("%.2f ms\n",(finish-start));
        cout<<"------------------------------------------------"<<endl;
	}

    return 0;
}

unsigned __int64 Integer_Divide_M(int n)
{
	int i, j, k;
	unsigned __int64 m_result;
	for (i = 0; i <= n; i++)
	{
		a[i] = 1;
		b[i] = 1;
	}
	for (i = 2; i <= n; i++)
	{
		for (j = 1; j * i <= n; j++)
		{
			for (k = 0; k + j * i <= n; k++)
			{
			    m_result = b[j * i + k] ;
				b[j * i + k] += a[k];
				if ( b[j * i + k] <= m_result )
                {
                    printf("\n overflow\n",j*i+k);
                    return 0;
                }
			}
		}
		for (k = 0; k <= n; k++)
			a[k] = b[k];
	}
	return a[n];
}
